// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.cartridges.meta.metafacades;

import java.util.Collection;
import org.andromda.metafacades.uml.ClassifierFacade;

/**
 * <p>
 * Facade for use in the andromda-meta cartridge. It hides a
 * Classifier that represents a <<metafacade>> object.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface Metafacade
    extends ClassifierFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isMetafacadeMetaType();

    /**
     * <p>
     * All generalization links (including all parents)
     * </p>
     * @return Collection<Metafacade>
     */
    public Collection<Metafacade> getAllParents();

    /**
     * <p>
     * The fully qualified name for the implementation of the
     * metafacade.
     * </p>
     * @return String
     */
    public String getFullyQualifiedLogicImplName();

    /**
     * <p>
     * The fully qualified name for the metafacade "Logic" class.
     * </p>
     * @return String
     */
    public String getFullyQualifiedLogicName();

    /**
     * <p>
     * The number of parents this metafacade has.
     * </p>
     * @return int
     */
    public int getGeneralizationCount();

    /**
     * <p>
     * The 'Logic' file location.
     * </p>
     * @return String
     */
    public String getLogicFile();

    /**
     * <p>
     * The 'Logic' implementation file location.
     * </p>
     * @return String
     */
    public String getLogicImplFile();

    /**
     * <p>
     * The name of the 'Logic' implementation name.
     * </p>
     * @return String
     */
    public String getLogicImplName();

    /**
     * <p>
     * The name of the metafacade 'Logic' class.
     * </p>
     * @return String
     */
    public String getLogicName();

    /**
     * <p>
     * The package name to which the 'Logic' metafacade classes are
     * generated.
     * </p>
     * @return String
     */
    public String getLogicPackageName();

    /**
     * 
     * @return ClassifierFacade
     */
    public ClassifierFacade getMetaclass();

    /**
     * <p>
     * Gets all method information as a collection of MethodData
     * instances for the metafacade.
     * </p>
     * @return Collection
     */
    public Collection getMethodDataForPSM();

    /**
     * <p>
     * Gets all inherited method information as a collection of
     * MethodData instances for the given superMetafacade.
     * </p>
     * @param superMetafacade ClassifierFacade
     * @return Collection
     */
    public Collection getMethodDataForPSM(ClassifierFacade superMetafacade);

    /**
     * <p>
     * Indicates if the meta class construct argument requires a cast
     * to the super metafacade's metaclass.
     * </p>
     * @return boolean
     */
    public boolean isConstructorRequiresMetaclassCast();

    /**
     * <p>
     * True/false depending on whether or not this class's metaclass is
     * a direct dependency (true) or an inherited dependency (false).
     * </p>
     * @return boolean
     */
    public boolean isMetaclassDirectDependency();

    /**
     * <p>
     * Indicates if the metafacade requires a delegate for inheritance
     * instead of actual inheritance.  This is true, when the
     * metafacade is inheriting from a metafacade from a different
     * package (since that means it will most likely be a cartridge
     * metafacade inheriting from a set of shared metafacades for a
     * meta model).
     * </p>
     * @return boolean
     */
    public boolean isRequiresInheritanceDelegatation();
}